*
*   callers 95.1005
*
*   (c) 1993,95 RGware
*   by Tom Whittenburg
*   The Burg Board System
*   (806) 372-1973 BBS
*   (806) 374-6340 FAX
*   (806) 372-7788 VOICE

*   A replacement for the TBBS TYPE 22 command

*   05/25/93 Changed the background color from blue to black
*   06/05/93 Fixed PAUSE background color
*   09/21/93 Changed each line to a different color
*   02/21/94 Cleaned up the color display a little
*            Supports colors for 64 lines
*   10/05/95 Made a little better 4 lines color scheme

*   Set up stuff
DECLARE cc[64]
PUBLIC baud
SET ESCAPE OFF
SET EXCLUSIVE OFF
SET BELL OFF

cc[1] = "bg+"
cc[2] = "g+"
cc[3] = "g"
cc[4] = "bg"
cc[5] = "bg+"
cc[6] = "g+"
cc[7] = "g"
cc[8] = "bg"
cc[9] = "bg+"
cc[10] = "g+"
cc[11] = "g"
cc[12] = "bg"
cc[13] = "bg+"
cc[14] = "g+"
cc[15] = "g"
cc[16] = "bg"
cc[17] = "bg+"
cc[18] = "g+"
cc[19] = "g"
cc[20] = "bg"
cc[21] = "bg+"
cc[22] = "g+"
cc[23] = "g"
cc[24] = "bg"
cc[25] = "bg+"
cc[26] = "g+"
cc[27] = "g"
cc[28] = "bg"
cc[29] = "bg+"
cc[30] = "g+"
cc[31] = "g"
cc[32] = "bg"
cc[33] = "bg+"
cc[34] = "g+"
cc[35] = "g"
cc[36] = "bg"
cc[37] = "bg+"
cc[38] = "g+"
cc[39] = "g"
cc[40] = "bg"
cc[41] = "bg+"
cc[42] = "g+"
cc[43] = "g"
cc[44] = "bg"
cc[45] = "bg+"
cc[46] = "g+"
cc[47] = "g"
cc[48] = "bg"
cc[49] = "bg+"
cc[50] = "g+"
cc[51] = "g"
cc[52] = "bg"
cc[53] = "bg+"
cc[54] = "g+"
cc[55] = "g"
cc[56] = "bg"
cc[57] = "bg+"
cc[58] = "g+"
cc[59] = "g"
cc[60] = "bg"
cc[61] = "bg+"
cc[62] = "g+"
cc[63] = "g"
cc[64] = "bg"

*   get Command Line Parameters
temp = UPPER(OPTDATA())
sp = AT("&",temp)
od = RIGHT(temp,LEN(temp)-sp)
*    check if invisible flag is set
inv = ULPEEK(238,1)

*   if CLP is longer than 4 characters, get BPS
IF LEN(od) > 4
     baud = RIGHT(od,LEN(od)-4)
     od = LEFT(od,4)
ENDIF

*   if CLP is ADDN, add name to list
add = "yes"
IF od = "ADDN"
     IF ULINE() = "00"
          add = "no"
     ENDIF
     IF inv <> 0
          add = "no"
     ENDIF
     IF add = "yes"
          DO addn
     ENDIF
ENDIF

*   if CLP is VIEW, view the list
IF od = "VIEW"
     DO view
ENDIF

*   if CLP is MAXX, reduce list to maximum length
IF od = "MAXX"
     DO maxx
ENDIF

QUIT

*   add name to list
PROCEDURE addn
*   convert date to string in form mm/dd/yy
     t = DTOS(DATE())
     y = LEFT(t,4)
     m = SUBSTR(t,5,2)
     d = RIGHT(t,2)
     dt = m + "/" + d + "/" + RIGHT(y,2)
*   open the file and append a blank record to the end
     USE callers.dbf
     APPEND BLANK
*   replace the blank record with the values of new caller
     REPLACE nme WITH RTRIM(UNAME())
     REPLACE loc WITH RTRIM(ULOCATION())
     REPLACE lion WITH ULINE()
     REPLACE bps WITH baud
     REPLACE dte WITH dt
     REPLACE tm WITH TIME()
     QUIT
RETURN

*   view the list
PROCEDURE view
*   if caller is using ANSI, set colors and clear the screen
     IF UANSI()
          SET COLOR TO w+/n
          CLEAR
          SET COLOR TO g+/n
     ENDIF
*   display header
     ? "               callers 95.1005     (c) RGware    by Tom Whittenburg"
     ?
     ? "                     Press <A> to abort, <P> to pause"
*   dummy starting date, so date prints before first name in list
     dd = "01/01/01"
*   initialize color toggle and INKEY value
     cl = 0
     in = 0
*   open file and go to the last record
     USE callers.dbf
     GOTO BOTTOM
*   do it from the last record to the first
     DO WHILE .NOT. BOF()
*   if date of previous call doesn't equal date of current call
*    set colors and print call date
          IF dte <> dd
               IF UANSI()
                    SET COLOR TO bg+/n
               ENDIF
               ?
               ? "*-*-* "
               ?? dte
               ?? " *-*-*"
          ENDIF
*       increment color toggle
          cl = cl + 1
*       toggle color
          IF UANSI()
               ll = VAL(lion)
               colr = cc[ll] + "/n"
               SET COLOR TO &colr
          ENDIF
*       if a key is pressed ...
          in = INKEY()
          IF in <> 0
*           if it is lowercase, change to upper
               IF in > 80
                    in = in - 32
               ENDIF
*           if it is A
               IF in = 65
                    QUIT
               ENDIF
*           if it is S, invisible, compatible with TBBS default
               IF in = 83
                    QUIT
               ENDIF
*           if it is P
               IF in = 80
                    IF UANSI()
                         SET COLOR TO r/n
                    ENDIF
                    wt = ""
                    WAIT "*-*-* PAUSED, Press any key to continue" TO wt
                    ?? "    <A>bort or <P>ause"
                    IF UANSI()
                         ll = VAL(lion)
                         colr = cc[ll] + "/n"
                         SET COLOR TO &colr
                    ENDIF
               ENDIF
          ENDIF
*       trim spaces from right of user name and pad with periods
*        and print the fields of current record
          nm = RTRIM(nme)
          ? nm
          ?? " from "
          lc = RTRIM(loc)
          ?? lc
          IF (LEN(nm) + LEN(lc)) < 38
               ?? LEFT("..............................",(38 - (LEN(nm) + LEN(lc))))
          ENDIF
          ?? " on line "
          ?? lion
          ?? " at "
          ?? bps
          ?? " baud "
          ?? tm
*       set previous call date to current call date
          dd = dte
*       move to previous record
          SKIP -1
     ENDDO
*   set color and wait for a key press
     ?
     IF UANSI()
          SET COLOR TO r/n
     ENDIF
     key = ""
     WAIT "*-*-* Press any key to exit *-*-*" TO key
     QUIT
RETURN

*   reduce list to Maximum
PROCEDURE maxx
     n1 = ""
     o1 = ""
     l1 = ""
     b1 = ""
     d1 = ""
     t1 = ""
*   get maximum size of file from ASCII file
     FOPEN Handle CallMaxx.DAT 10
     FLREAD Handle Size Record
     FCLOSE
*   put that string value into a numeric variable
     numB = VAL(Record)
*   set up temporary file
     COPY FILE tempcall.dbf TO calltemp.dbf
*   use current file as file A
     SELECT A
     USE callers.dbf
*   use temporary file as file B
     SELECT B
     USE calltemp.dbf
*   get number of records in current file
     SELECT A
     lr = RECCOUNT()
*   if there aren't enough records, QUIT
     IF lr <= numb
          ? "Not enough records to pack database"
          QUIT
     ENDIF
*   display message that your are packing
     ? "Packing database from "
     ?? LTRIM(STR(lr))
     ?? " records to "
     ?? LTRIM(STR(numB))
*   sr is the number of records to delete from current file
     sr = lr - numb
     SELECT A
     GOTO sr
     SELECT A
*   do while there are still records in current file
     DO WHILE .NOT. EOF()
          SELECT A
*   set values of record in current file to temp variables
          n1 = nme
          o1 = loc
          l1 = lion
          b1 = bps
          d1 = dte
          t1 = tm
*       append blank record to temporary file
          SELECT B
          APPEND BLANK
*       replace blank record with temp variables
          REPLACE nme WITH n1
          REPLACE loc WITH o1
          REPLACE lion WITH l1
          REPLACE bps WITH b1
          REPLACE dte WITH d1
          REPLACE tm WITH t1
*       go to next record of current file
          SELECT A
          SKIP 1
     ENDDO
     CLOSE ALL
     ? "Erase original CALLERS.DBF"
     ERASE callers.dbf
     ? "RENAMing temporary file to CALLERS.DBF"
     RENAME calltemp.dbf TO callers.dbf
RETURN
